<?php
/***************************************************************
 *  Copyright n otice
 *
 *  (c) 2004 Thomas Wendt (thomas.wendt@berliner-stadtplan.com)
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * Module 'Acronyms' for the 'akronymmanager' extension.
 *
 * @author	Thomas Wendt/ Uwe Kiefer <kiefer@sunbeam-berlin.de>
 */
// DEFAULT initialization of a module [BEGIN]
unset($MCONF);
//if (!isset($MCONF)) {
require ("conf.php");
//}



if (tx_sbakronymmanager_compatibility::getInstance()->int_from_ver(TYPO3_version) < 6002000) {
	require ($BACK_PATH."init.php");
	require ($BACK_PATH."template.php");
}

$GLOBALS['LANG']->includeLLFile('EXT:sb_akronymmanager/mod1/locallang.php');

//weg für 6.2 require_once (PATH_t3lib."class.t3lib_scbase.php");

$GLOBALS['BE_USER']->modAccess($MCONF,1);	// This checks permissions and exits if the users has no permission for entry.
// DEFAULT initialization of a module [END]


class tx_sbakronymmanager_module1 extends t3lib_SCbase {
	var $pageinfo;
	var $language;

	/**
	 *
	 */
	function init()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

		parent::init();

		/*
		if (t3lib_div::_GP("clear_all_cache"))	{
			$this->include_once[]=PATH_t3lib."class.t3lib_tcemain.php";
		}
		*/
	}

	/**
	 * Adds items to the ->MOD_MENU array. Used for the function menu selector.
	 */
	function menuConfig()	{
		global $LANG;
		$this->MOD_MENU = Array (
			"function" => Array (
				"1" => $LANG->getLL("function1"),
				"2" => $LANG->getLL("function2"),
				"3" => $LANG->getLL("function3"),
			)
		);
		parent::menuConfig();

	}

		// If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
	/**
	 * Main function of the module. Write the content to $this->content
	 */
	function main()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;
		// Access check!
		// The page will show only if there is a valid page and if this page may be viewed by the user
		$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
		$access = is_array($this->pageinfo) ? 1 : 0;
		if (($this->id && $access) || ($BE_USER->user["admin"] && !$this->id))	{

				// Draw the header.
			$this->doc = t3lib_div::makeInstance("mediumDoc");
			$this->doc->backPath = $BACK_PATH;
			$this->doc->form='<form action="" method="POST">';

				// JavaScript
			$this->doc->JScode = '
				<script language="javascript" type="text/javascript">
					script_ended = 0;
					function jumpToUrl(URL)	{
						document.location = URL;
					}
				</script>
			';
			$this->doc->postCode='
				<script language="javascript" type="text/javascript">
					script_ended = 1;
					if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
				</script>
			';

			$headerSection = $this->doc->getHeader("pages",$this->pageinfo,$this->pageinfo["_thePath"])."<br>".$LANG->sL("LLL:EXT:lang/locallang_core.php:labels.path").": ".t3lib_div::fixed_lgd_cs($this->pageinfo["_thePath"],-50);

			$this->content.=$this->doc->startPage("Acronym Manager");
			$this->content.=$this->doc->header($LANG->getLL("Acronym Manager"));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->section("",$this->doc->funcMenu($headerSection,t3lib_BEfunc::getFuncMenu($this->id,"SET[function]",$this->MOD_SETTINGS["function"],$this->MOD_MENU["function"])));
			$this->content.=$this->doc->divider(5);


			// Render content:
			$this->moduleContent();


			// ShortCut
			if ($BE_USER->mayMakeShortcut())	{
				$this->content.=$this->doc->spacer(20).$this->doc->section("",$this->doc->makeShortcutIcon("id",implode(",",array_keys($this->MOD_MENU)),$this->MCONF["name"]));
			}

			$this->content.=$this->doc->spacer(10);
		} else {
				// If no access or if ID == zero

			$this->doc = t3lib_div::makeInstance("mediumDoc");
			$this->doc->backPath = $BACK_PATH;

			$this->content.=$this->doc->startPage($LANG->getLL("title"));
			$this->content.=$this->doc->header($LANG->getLL("title"));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->spacer(10);
		}
	}

	/**
	 * Prints out the module HTML
	 */
	function printContent()	{

		$this->content.=$this->doc->endPage();
		echo $this->content;
	}


  function XorArrays($strArray1,$strArray2)	{
  	echo "<br>XorArrays<br>1:<br>$strArray1<br>2:<br>$strArray2<br>";
    if(count($strArray1) && (count($strArray2))) {

      //collect the indices of the elements that exist in both arrays
      foreach ($strArray1 as $i => $ivalue) {
        if (trim($strArray1[$i])=="") $iInd[] = $i;    //remove empty lines
        foreach ($strArray2 as $j => $jvalue) {
          if (trim($strArray2[$j])=="") $jInd[] = $j;   //remove empty lines
          if(!strcmp(trim($strArray1[$i]),trim($strArray2[$j]))) {
            $iInd[] = $i;
            $jInd[] = $j;
          }
        }
      }

      //remove all elements that are in both arrays from both arrays
      if (is_array($iInd)) {
        foreach ($iInd as $i) {
          unset ($strArray1[$i]);
        }
      }

      if (is_array($jInd)) {
        foreach ($jInd as $j) {
          unset ($strArray2[$j]);
        }
      }
    }
    $arr = array($strArray1,$strArray2);
    //print_r($arr);

    return $arr;
  }

	function updateDatabase($strForm, &$strDB, $type) {

		$GLOBALS['TYPO3_DB']->sql_query("DELETE FROM tx_sbakronymmanager_data WHERE type='$type'");

		$arr = Array();

		$arrForm = explode("\n", $strForm);

		if($arrForm) {
			foreach($arrForm as $line) {
				if(trim($line)<>'') {
					$arrLine = explode('|', trim($line));
					// clear double spaces
					$arrSpacer = explode(' ',$arrLine[0]);
					$arrWord = Array();
					foreach($arrSpacer as $part) if($part<>'') $arrWord[] = $part;
					$arr[implode(' ', $arrWord)] = Array($arrLine[1], $arrLine[2]);
				}
			}
		}
		if($arr) {
			$strDB = '';
			foreach($arr as $word => $data) {
				//$GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_sbakronymmanager_data', Array('pid' => '167','word' => $word, 'mean' => $data[0], 'lang' => $data[1], 'type' => $type, 'glossary' => $glossary));
				$GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_sbakronymmanager_data', Array('word' => $word, 'mean' => $data[0], 'lang' => $data[1], 'type' => $type, 'glossary' => $glossary));

				$strDB .= $word.'|'.$data[0].'|'.$data[1]."\n";
			}
		}
	}

	/**
	 * Generates the module content
	 */
	function moduleContent() {
    global $LANG;

    switch((string)$this->MOD_SETTINGS["function"])	{
			case 1: {
					//
					// create function Settings
					//
			        $DBabbr='';
			        $DBacro='';
			        $DBspan='';
			        $DBterm='';
			        $this->nowrap = Array();
			        $this->phrase = Array();
			    		$this->hyphenate = Array();
			        $this->pmax = 0;
			        $this->hmax = 0;

				    //create  abbreviation string from DB
				    $query=$GLOBALS['TYPO3_DB']->exec_SELECTquery('*','tx_sbakronymmanager_data','deleted=false','');

				    while ($line=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($query)) {
         	/*
 			 * to prevent cross-site-scripting
 			 */
				    	$line["word"] = $this->sanitize($line["word"]);
				    	$line["mean"] = $this->sanitize($line["mean"]);
				    	$line["lang"] = $this->sanitize($line["lang"]);
						if($row['type']<>'nowrap') {
				        	//$DBline = $line["word"].'|'.$line["mean"].'|'.$line["lang"].'|'."uid: ".$line["uid"].'|'."\n";
							$DBline = $line["word"].'|'.$line["mean"].'|'.$line["lang"]."\n";
							//echo ($DBline);
				        	if($space=substr_count($line['word'], ' ')) $this->phrase[$space][] = $line['word'];
						    $this->pmax = max($this->pmax, $space);
							if($space=substr_count($line['word'], '-')) $this->hyphenate[$space][] = $line['word'];
						    $this->hmax = max($this->hmax, $space);
						}
				        switch($line["type"]) {
				        	case 'abbr'    : $DBabbr .= $DBline; break;
				        	case 'acronym' : $DBacro .= $DBline; break;
				        	case 'span'    : $DBspan .= $DBline; break;
				        	case 'term'    : $DBterm .= $DBline; break;
				        	case 'nowrap'  : $this->nowrap[] = $line["word"]; break;
						}
					}

				    //create strings  from Form    , removing whitespaces and '\r' that were added automatically
			        $Fabbr = str_replace("\r","",$this->sanitize(t3lib_div::_GP("abbr")));
			        $Facro = str_replace("\r","",$this->sanitize(t3lib_div::_GP("acronym")));
			        $Fspan = str_replace("\r","",$this->sanitize(t3lib_div::_GP("span")));
			        $Fterm = str_replace("\r","",$this->sanitize(t3lib_div::_GP("term")));


			        // if form has already data- it will be compared with the DB data and the DB will be updated if needed
					if ($Fabbr OR $Facro OR $Fspan OR $Fterm) {
				       	//if form and DB are not identicle
				       	if ($Fabbr <> $DBabbr) $this->updateDatabase($Fabbr, $DBabbr, 'abbr');
				        if ($Facro <> $DBacro) $this->updateDatabase($Facro, $DBacro, 'acronym');
				        if ($Fspan <> $DBspan) $this->updateDatabase($Fspan, $DBspan, 'span');
				        if ($Fterm <> $DBterm) $this->updateDatabase($Fterm, $DBterm, 'term');
				   	}

			        //
			        // create container
			        //
					$sumAbbr = 0;
					$sumSpan = 0;
					$sumAcro = 0;
					$sumTerm = 0;
					// abbrevations
			        $arrAbbr = explode("\n", $DBabbr);
			        if(count($arrAbbr)) {
				    	foreach($arrAbbr as $line) {
				            if(!empty($line)) {
				              $arrItem = explode('|',$line);
				              $this->abbr['word'][$sumAbbr] = trim($arrItem[0]); $this->abbr['mean'][$sumAbbr] = trim($arrItem[1]); $this->abbr['lang'][$sumAbbr] = trim($arrItem[2]);
				              $sumAbbr++;
				            }
				        }
				     }
					// acronyms
				    $arrAcro = explode("\n", $DBacro);
			        if(count($arrAcro)) {
			          foreach($arrAcro as $line) {
			            if(!empty($line)) {
			              $arrItem = explode('|',$line);
			              $this->acro['word'][$sumAcro] = trim($arrItem[0]); $this->acro['mean'][$sumAcro] = trim($arrItem[1]); $this->acro['lang'][$sumAcro] = trim($arrItem[2]);
			              $sumAcro++;
			            }
			          }
			        }
					// foeign language terms
				    $arrSpan = explode("\n", $DBspan);
				    if(count($arrSpan)) {
				    	foreach($arrSpan as $line) {
				        	if(!empty($line)) {
				              $arrItem = explode('|',$line);
				              $this->span['word'][$sumSpan] = trim($arrItem[0]); $this->span['mean'][$sumSpan] = trim($arrItem[1]); $this->span['lang'][$sumSpan] = trim($arrItem[2]);
				              $sumSpan++;
				            }
				        }
				    }
					// technical terms
				    $arrTerm = explode("\n", $DBterm);
				    if(count($arrTerm)) {
				    	foreach($arrTerm as $line) {
				            if(!empty($line)) {
				              $arrItem = explode('|',$line);
				              $this->term['word'][$sumTerm] = trim($arrItem[0]); $this->term['mean'][$sumTerm] = trim($arrItem[1]); $this->term['lang'][$sumTerm] = trim($arrItem[2]);
				              $sumTerm++;
				            }
				        }
				    }

			        //
			        // create settings for highlights
			        //
			        $style = array('abbr' => '', 'acronym' => '', 'span' => '', 'term' => '');
			        foreach($style as $type => $data) {
			        	$qset = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*','tx_sbakronymmanager_settings',"type='$type'",'');
				        $str = '';
				        if($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qset)) {
				            if(!empty($row['color'])) $str .= 'background-color:'.$row['color'].';';
				            if($row['bold']) $str .= 'font-weight:bold;';
				            if($row['italic']) $str .= 'font-style:italic;';
				            if($row['underline']) $str .= 'text-decoration:underline;';
				            if($row['uppercase']) $str .= 'text-transform:uppercase;';
				        }
				        $this->style[$type] = $str;
				     }

					$content.='<form>';
					$content.='<strong>'.$LANG->getLL("abbr").'</strong><br />';
					$content.='<textarea name="abbr" style="width:100%;height:100px;">'.$DBabbr.'</textarea>';
					$content.='<strong>'.$LANG->getLL("acronym").'</strong><br />';
					$content.='<textarea name="acronym" style="width:100%;height:100px;">'.$DBacro.'</textarea>';
					$content.='<strong>'.$LANG->getLL("span").'</strong><br />';
					$content.='<textarea name="span" style="width:100%;height:100px;">'.$DBspan.'</textarea>';
					/*----------- terms/ Fachbegriffe (span) ----------------------------------------------------------*/
					$content.='<strong>'.$LANG->getLL("term").'</strong><br />';
					$content.='<textarea name="term" style="width:100%;height:100px;">'.$DBterm.'</textarea>';
					/*--- Don't enable this Button. It isn't compatible with the glossary! ------------
					$content.='<!-- <input type="submit" value="Update'.$LANG->getLL("update").'" />-->'; */
					$content.='</form>';

					$this->content.=$this->doc->section($LANG->getLL("longtitle"),$content,0,1);
					$content="";

					$pageID=intval(t3lib_div::_GET("id"));
					if ($pageID) $where="uid='$pageID' AND ";
					$result=$GLOBALS['TYPO3_DB']->exec_SELECTquery('title,uid','pages',$where.'hidden="0" AND deleted=false','sorting');
					while($zeile=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($result))
						{
							$actualtitle=$this->sanitize($zeile['title']);
							$content='';

							$resulta=$GLOBALS['TYPO3_DB']->exec_SELECTquery('*','tt_content','hidden="0" AND deleted=false AND pid='.$zeile["uid"].' AND bodytext!="" AND CType!="mailform" AND CType!="table"','');
							while ($zeilea=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($resulta))
							{
								$content.="<p>";
								$content.="<br /><strong>";
					            if($sumAbbr || $sumAcro || $sumSpan) {
					              $content.= $this->check($this->sanitize($zeilea['header']));
									      $check=$this->check($this->sanitize($zeilea['bodytext']));
					            } else {
					              $content.= $this->sanitize($zeilea['header']);
									      $check=$this->sanitize($zeilea['bodytext']);
					            }
					            $content.="</strong> (".$this->sanitize($zeilea['CType']).")<br />";
								$content.=$check;

								//$GLOBALS['TYPO3_DB']->exec_UPDATEquery('tt_content','uid="'.$zeilea['uid'].'"',Array("bodytext"=>$check));

								$content.="</p>";
							}
							$content.='</table>';
							$this->content.=$this->doc->section($actualtitle,$content,1,1);
						}
					break;
			}
			case 2: {
		          	//
		          	// create module function Settings
		          	//


			        // default settings
			        $settings['abbr']    = array('color' => 'yellow', 'bold' => 0, 'italic' => 0, 'underline' => 0, 'uppercase' => 0);
			        $settings['acronym'] = array('color' => 'lightgreen', 'bold' => 0, 'italic' => 0, 'underline' => 0, 'uppercase' => 0);
			        $settings['span']    = array('color' => 'silver', 'bold' => 0, 'italic' => 0, 'underline' => 0, 'uppercase' => 0);
			        $settings['term']    = array('color' => 'lightblue', 'bold' => 0, 'italic' => 0, 'underline' => 0, 'uppercase' => 0);


			        // create new page entry (the pid of the glossary in pagetree)
			        $qpage = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*','tx_sbakronymmanager_settings',"type='page'",'');
			        if(!$GLOBALS['TYPO3_DB']->sql_num_rows($qpage)) {
				         // create new page id
				            $GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_sbakronymmanager_settings',array('type' => 'page', 'cruser_id' => 0));
				    	}
				    	else {
				            $row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qpage);
				            if($row) $page_db = $row['cruser_id'];
				     }
					 // creage new setting entry
				     foreach($settings as $type => $data) {
				     	$qset = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*','tx_sbakronymmanager_settings',"type='$type'",'');
				            if(!$GLOBALS['TYPO3_DB']->sql_num_rows($qset)) {
				              $arr = $settings[$type];
				              $arr['type'] = $type;
				              $GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_sbakronymmanager_settings',$arr);
				            }
				        }

				     // get data from POST var
				     $update_db = t3lib_div::_POST('update_db');

				     if(isset($update_db)) {
				     	$post = t3lib_div::_POST();
				            //print_r($post);

				            $page_id = t3lib_div::_POST('pageid');
				            if(!is_numeric($page_id)) {
				              $page_id = $page_db;
				            } else {
				              $page_id = intval($page_id);
				            }

				            // update setting parameter
				            if($page_id <> $page_db) {
				              $arrUpdate['cruser_id'] = $page_id;
				              $GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_sbakronymmanager_settings',"type='page'",$arrUpdate);
				              $GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_sbakronymmanager_data','1',array('pid' => $page_id));
				            }
				            // update the "pid" with the pid value
				            $GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_sbakronymmanager_data','1',array('pid' => $page_id));

				            // update settings from POST var
				            foreach($settings as $type => $data) {
				              $arrUpdate = $settings[$type];
				              foreach($data as $name => $value) {
				                $param = t3lib_div::_POST($type.'_'.$name);
				                if(isset($param)) {
				                    if($name == 'color') {
				                      $arrUpdate[$name] = $this->sanitize($param);
				                    } else {
				                      $arrUpdate[$name] = 1;
				                    }
				                }
				              }
				              $GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_sbakronymmanager_settings',"type='$type'",$arrUpdate);
				              $settings[$type] = $arrUpdate;
				            }

				            // update forbidden TAGs from POST var
										$forbiddentags = $this->sanitize(t3lib_div::_POST('forbiddentags'));
										$GLOBALS['TYPO3_DB']->sql_query("DELETE FROM tx_sbakronymmanager_data WHERE type='nowrap'");
										if($forbiddentags<>'') {
											$arrTAGs = explode("\n", str_replace("\r", '', $forbiddentags));
											unset($forbiddentags);
											if($arrTAGs) {
												foreach($arrTAGs as $tag) $arrNew[trim($tag)] = trim($tag);
												foreach($arrNew as $tag) {
													$GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_sbakronymmanager_data',array('type' => 'nowrap', 'cruser_id' => 0, 'word' => trim($tag)) );
													$forbiddentags .= $tag."\n";
												}
										}

									}

			          } else {

			            // read page id
			            $qpage = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*','tx_sbakronymmanager_settings','type=\'page\'','');
			            if($qpage) {
			              $row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qpage);
			              $page_id = $row['cruser_id'];
			            }

			            // read setting parameter
			            foreach($settings as $type => $data) {
			              $qset = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*','tx_sbakronymmanager_settings',"type='$type'",'');
			              if($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qset)) {
			                $settings[$type]['color'] = $row['color'];
			                $settings[$type]['bold'] = $row['bold'];
			                $settings[$type]['italic'] = $row['italic'];
			                $settings[$type]['underline'] = $row['underline'];
			                $settings[$type]['uppercase'] = $row['uppercase'];
			              }
			            }

			            // read forbidden TAGs
			            $forbiddentags = '';
			            $qtags = $GLOBALS['TYPO3_DB']->exec_SELECTquery('word','tx_sbakronymmanager_data',"type='nowrap'",'');
			            if($qtags) {
			            	while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qtags)) {
			            		$forbiddentags .= $this->sanitize($row['word'])."\n";
										}
									}

			          }

			          //
			          // generate formular
			          //
			  				$content.='<form>';
			  				$content.='<input type="hidden" name="update_db" value="1" />';
			  				$content.='<table border="0">';
			  				$content.='<tr><td colspan="2"><strong>'.$LANG->getLL("pageid").'</strong>:</td><td><input type="text" name="pageid" value="'.$page_id.'" size="5" /></td></tr>';
			  				$content.='</table>';

			  				foreach($settings as $type => $data) {
			  				  $content.='<br /><br /><strong>'.$LANG->getLL("fontstyle").': '.$LANG->getLL($type).'</strong><br />';
			  				  $content.='<table border="0">';
			  				  $content.='<tr><td style="text-align:right;">'.$LANG->getLL("color").':</td><td><input type="text" name="'.$type.'_color" value="'.$data['color'].'" /></td></tr>';
			  				  $content.='<tr><td style="text-align:right;">'.$LANG->getLL("bold").':</td><td><input type="checkbox" name="'.$type.'_bold"'.($data['bold']?' checked="checked"':'').' /></td></tr>';
			  				  $content.='<tr><td style="text-align:right;">'.$LANG->getLL("italic").':</td><td><input type="checkbox" name="'.$type.'_italic"'.($data['italic']?' checked="checked"':'').' /></td></tr>';
			  				  $content.='<tr><td style="text-align:right;">'.$LANG->getLL("underline").':</td><td><input type="checkbox" name="'.$type.'_underline"'.($data['underline']?' checked="checked"':'').' /></td></tr>';
			  				  $content.='<tr><td style="text-align:right;">'.$LANG->getLL("uppercase").':</td><td><input type="checkbox" name="'.$type.'_uppercase"'.($data['uppercase']?' checked="checked"':'').' /></td></tr>';
			  				  $content.='</table>';
			          }
			          // unerlaubte TAGs
								$content.='<br /><strong>'.$LANG->getLL("forbiddentags").'</strong><br />';
								$content.='<textarea name="forbiddentags" style="width:100%;height:100px;">'.$forbiddentags.'</textarea>';

			  				$content.='<br />
								<input type="submit" value="'.$LANG->getLL("update").'"/>
							</form>';

			  				$this->content.=$this->doc->section($LANG->getLL("function2"),$content,0,1);
								$this->content.=$this->doc->section($actualtitle,'',1,1);
							  break;
			       		 }
				case 3: {
				          //
				          // create module function Help
				          //
				          $this->content.=$this->doc->section($LANG->getLL("function3"),$content,0,1);
				          $content.='Noch keine Hilfe hier :-(.';

				          $content = '<h1>Configuration</h1>';
				          $content .= 'To use the Akronymmanager include the extension into the TypoScript template:<br /><br />';
				          $content .= '<pre>postUserFunc = tx_akronymmanager_pi1->check</pre>';
				          $content .= '<br /><br />';
				          $content .= '<br /><strong>Example:</strong><br /><br />';
				          $content .= '<pre>
							marks.CONTENT = TEXT
							marks.CONTENT < styles.content.get

							## Content Rendering with Akronymmanager
							marks.CONTENT.stdWrap {
					    	postUserFunc = tx_akronymmanager_pi1->check
							}</pre>';

					      $this->content.=$content;
				          break;
		        }
		      }
			}

		/**
		 * Main acronymmanager function: replaces acronyms, abbrevations and foeign language terms
	 *
	 * @param	string  $text : text to mark
	 * @param	array		$abbr : abbrevation array
	 * @param	array		$acro : acronym array
	 * @param	array		$span : foeign language term array
	 * @param	array		$style : font style settings
	 * @return	string		$output: marked text
	 */
	function check($text) {
    global $LANG;
    $this->language = $LANG->lang;
    if($this->language == 'default') $this->language = 'en';
    //
		// define seperators
    //
		$exploder = array(' ','-',')','(',']','[',',',';',':','!','?','"',"\n","\r",'&quot;','&nbsp;');


		//
		// filter single words and tags
		//
		$a=0;
		for($i=0;$i<strlen($text);$i++) {
			if (strstr($text[$i],"<")) {

        // handle tags
				$u=$i;
				$end[$a].=$text[$i];

				do {
					$i++;
					$end[$a].=$text[$i];
				}	while(($text[$i]!=">") AND ($text[($i+1)]!="<") AND ($text[$i]!=""));

				if ($text[$i]=="<" AND ($i>($u+1))) {
					$a++;
					if ($word[$a]=="") $word[$a] = '~~NO~WORD~~';
				} else {
					if ($word[$a]=="") $word[$a] = '~~NO~WORD~~';
					$a++;
				}

			}	else if (in_array($text[$i],$exploder)) {

        // handle new word
				$end[$a].=$text[$i];
				if ($word[$a]=="") $word[$a] = '~~NO~WORD~~';
				$a++;

			}	else if (in_array($sub=substr($text, $i, 6),$exploder)) {

        // handle new word
				$end[$a].= $sub;
				$i += 5;
				if ($word[$a]=="") $word[$a] = '~~NO~WORD~~';
				$a++;

			}	else {

        // build word
        $word[$a] .= $text[$i];
      }
		}

    //
		// mark words
		//
    $this->cabbr = count($this->abbr['mean'])?true:false;
    $this->cacro = count($this->acro['mean'])?true:false;
    $this->cspan = count($this->span['mean'])?true:false;
    $this->cterm = count($this->term['mean'])?true:false;
		$this->lang = ' lang="%lang%" xml:lang="%lang%"';
		$this->strAbbr = '<span%s title="%s" style="'.$this->style['abbr'].'">%s</span>';
		$this->strAcro = '<acronym%s title="%s" style="'.$this->style['acronym'].'">%s</acronym>';
		$this->strTerm = '<span%s title="%s" style="'.$this->style['term'].'">%s</span>';
		$this->strNoTerm = '%s title="%s" style="'.$this->style['term'].'"';
		$this->strSpan = '<span%s title="%s" style="'.$this->style['span'].'">%s</span>';
		$this->strNoSpan = '%s title="%s" style="'.$this->style['span'].'"';

		$i=0;
		$currentWrap = '';

		while($i<sizeof($word)) {
			$i_step = 1;
			$i_end = $i;
			$this->getCurrentWrap($end[$i-1], $currentWrap, $this->nowrap);
			$sword = $word[$i];

			// looking for phrases
			$slong = $word[$i];
			for($j=1;$j<=$this->pmax;$j++) {
				$slong .= ' '.$word[$i+$j];
				if($this->phrase[$j] && in_array($slong, $this->phrase[$j])) {
					$sword = $slong;
					$i_step += $j;
					$i_end += $j;
				}
			}
			// looking for hyphenate words
			if($sword==$word[$i] && $end[$i]=='-') {
				$slong = $word[$i];
				for($j=1;$j<=$this->hmax;$j++) {
					$slong .= $end[$i+$j-1].$word[$i+$j];
					if($this->hyphenate[$j] && in_array($slong, $this->hyphenate[$j])) {
						$sword = $slong;
						$i_step += $j;
						$i_end += $j;
					}
				}
			}

	    $wrap = ($end[$i-1][0]=='<' && $end[$i-1][1]<>'/' && substr($end[$i_end],0,2)=='</') ? false : true;
      if($sword<>'~~NO~WORD~~') {
				if($currentWrap=='') {

	        $short = '';
	        if(substr($sword, -1) == '.') $short = substr($sword, 0, -1);

	        $replace = '';
					$newWord = $this->getWrapedWord($sword, $wrap, $replace);
					if($replace=='' && $newWord==$sword && $short<>'') {
						$newWord = $this->getWrapedWord($short, $wrap, $replace).'.';
					}
					if($replace<>'') {
						// use the wraped TAG instead of the span TAG
						$output = substr($output,0,-1).$replace;
					}


	  			$output .= $newWord;
  			} else {
  				$output .= $sword;
				}
			}
			$output .= $end[$i_end];
			$i += $i_step;
		}
		return $output;
	}

	function getCurrentWrap($item, &$wrap, $nowrap) {
		$strpos1 = strpos($item, ' ');
		$strpos2 = strpos($item, '>');
		if($strpos1 === false) $strpos1 = $strpos2;

		$item = trim(substr($item, 1, $strpos1));
		if($wrap<>'') {
			if(substr($item, 0, strlen($wrap)+1)=='/'.$wrap) $wrap = '';
		} else {
			if(in_array($item, $nowrap)) $wrap = $item;
		}
	}
	//
	function getWrapedWord($word, $wrap, &$replace) {

		$result = $word;

		if ($this->cacro && is_int($z=array_search($word,$this->acro['word']))) {
			$result = sprintf($this->strAcro, ($this->acro['lang'][$z]<>$this->language?str_replace('%lang%', $this->acro['lang'][$z], $this->lang):''), $this->acro['mean'][$z], $word);
    } else if ($this->cabbr && is_int($z=array_search($word,$this->abbr['word']))) {
			$result = sprintf($this->strAbbr, ($this->abbr['lang'][$z]<>$this->language?str_replace('%lang%', $this->abbr['lang'][$z], $this->lang):''), $this->abbr['mean'][$z], $word);
    } else if ($this->cspan && is_int($z=array_search($word,$this->span['word']))) {
      if($this->span['lang'][$z] <> $this->language) {
      	if($wrap) {
					$result = sprintf($this->strSpan, str_replace('%lang%', $this->span['lang'][$z], $this->lang), $this->span['mean'][$z], $word);
				} else {
					$replace = sprintf($this->strNoSpan, str_replace('%lang%', $this->span['lang'][$z], $this->lang), $this->span['mean'][$z]).'>';
				}
      }
    } else if ($this->cterm && is_int($z=array_search($word,$this->term['word']))) {
    	if($wrap) {
				$result = sprintf($this->strTerm, ($this->term['lang'][$z]<>$this->language?str_replace('%lang%', $this->term['lang'][$z], $this->lang):''), $this->term['mean'][$z], $word);
			} else {
				$replace = sprintf($this->strNoTerm, ($this->term['lang'][$z]<>$this->language?str_replace('%lang%', $this->term['lang'][$z], $this->lang):''), $this->term['mean'][$z]).'>';
			}
		}

		return $result;
	}

	function sanitize($txt) {
		global $TYPO3_CONF_VARS;
		$sTxt = htmlspecialchars(strip_tags($txt), ENT_QUOTES, '', false);
		return $sTxt;
	}

}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sb_akronymmanager/mod1/index.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sb_akronymmanager/mod1/index.php"]);
}




// Make instance:
$SOBE = t3lib_div::makeInstance("tx_sbakronymmanager_module1");
$SOBE->init();

// Include files?
foreach($SOBE->include_once as $INC_FILE)	include_once($INC_FILE);

$SOBE->main();
$SOBE->printContent();

?>
