<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2004 Thomas Wendt (thomas.wendt@berliner-stadtplan.com)
*  (c) 2006 Juergen Kindler (kindler@sunbeam-berlin.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'Acronym' for the 'sb_akronymmanager' extension.
 *
**/
class tx_sbakronymmanager_pi1 extends tslib_pibase {
	var $prefixId = "tx_sbakronymmanager_pi1";						// Same as class name
	var $scriptRelPath = "pi1/class.tx_sbakronymmanager_pi1.php";	// Path to this script relative to the extension dir.
	var $extKey = "sb_akronymmanager";								// The extension key.


	function main($content,$conf)	{
		return "Hello World!<HR>
			Here is the TypoScript passed to the method:".
					t3lib_div::view_array($conf);

	}

	/**
	 * Main acronymmanager function: replaces acronyms, abbrevations and foeign language terms
	 * Extended function: (1) set typolinks to glossary page if word exist in glossarDB
	 *                    (2) OR dosn't set a typolink when a glossarybox will appear on same page
	 *
	 * @param	string  	$text : text to mark
	 * @param	array		$conf : configuration array
	 * @return	string		$output: marked text
	 **/
	function check($text,$conf) {
	    $this->language = $this->LLkey;
		$this->glossaryonpage=$conf['glossary_on_page'];
    	$sysLanguageUid = $GLOBALS['TSFE']->config['config']['sys_language_uid'];
    	if ($sysLanguageUid == 0){
    		$this->glossaryEntryLabel=$conf ['glossaryEntryLabel.']['lang.']['default'];
    		}

    	if ($sysLanguageUid == 1){
    		$this->glossaryEntryLabel=$conf ['glossaryEntryLabel.']['lang.']['1'];
    		}


		// get glossary pageID ($glossary_pid) from DB
	    $qsetting = $GLOBALS['TYPO3_DB']->exec_SELECTquery('cruser_id','tx_sbakronymmanager_settings',"type='page'",'');
			if($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qsetting)) {
					$glossary_pid= $row['cruser_id'];
					$this->glossary_pid = $glossary_pid;
					$page_id=($GLOBALS['TSFE']->id);
					if ($GLOBALS['TSFE']->id==$this->glossary_pid){
						return $text;
					}
					$myURLname=$this->pi_getPageLink($GLOBALS['TSFE']->id);
			}

		// delete old index
			global $tx_sbakronymmanager_pi1_loopcount;
			$tx_sbakronymmanager_pi1_loopcount++;
			if($tx_sbakronymmanager_pi1_loopcount<2)$GLOBALS['TYPO3_DB']->sql_query("DELETE FROM tx_sbakronymmanager_index WHERE page_id='$page_id' AND sys_language_uid='$sysLanguageUid'");

	    // get acronyms from DB
	    $sumAbbr = 0;
	    $sumAcro = 0;
	    $sumSpan = 0;
	    $sumTerm = 0;
	    $nowrap = array();
	    $phrase = array();
	    $hyphenate = array();
	    $pmax = 0;
	    $hmax = 0;
	    $this->abbr['word'][] = '';
	    $this->acro['word'][] = '';
	    $this->span['word'][] = '';
	    $this->term['word'][] = '';
	    $linkurl='';

    if($sysLanguageUid>=1){
     	$select = '`uid`,`word`,`mean`,`lang`,`type`,`sys_language`,`sys_language_uid`,`showglossary`';
      	$where = '  hidden=0 AND deleted=0 AND sys_language_uid='.(int)$sysLanguageUid;
    }else{
      	$select = '`uid`,`word`,`mean`,`lang`,`type`,`sys_language`,`sys_language_uid`,`showglossary`';
       	$where = '  hidden=0 AND deleted=0 AND sys_language_uid='.(int)$sysLanguageUid;
    }
		$result = $GLOBALS['TYPO3_DB']->exec_SELECTquery($select,'tx_sbakronymmanager_data',$where,'');

		while($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($result)) {
			$rWord = $this->sanitize($row['word']);
			$rMean = $this->sanitize($row['mean']);
			$rLang = $this->sanitize($row['lang']);
				
			if($row['type']<>'nowrap') {
				if($space=substr_count($rWord, ' ')) $phrase[$space][] = $rWord;
        		$pmax = max($pmax, $space);
				if($space=substr_count($rWord, '-')) $hyphenate[$space][] = $rWord;
        		$hmax = max($hmax, $space);
			}

	      	switch($row['type']) {
	       		case 'abbr' : {
		     		$this->abbr['uid'][$sumAbbr] = $row['uid'];
		     		
			       	$this->abbr['word'][$sumAbbr] = $rWord;
			        $this->abbr['mean'][$sumAbbr] = $rMean;
			        $this->abbr['lang'][$sumAbbr] = $rLang;
			        
			    	$this->abbr['sys_language_uid'][$sumAbbr] = $row['sys_language_uid'];
			        $this->abbr['showglossary'][$sumAbbr] = $row['showglossary'];
			        $sumAbbr++;
			        break;
		        }
	      		case 'acronym' : {
	      		  	$this->acro['uid'][$sumAcro] = $row['uid'];
	      		  	
			        $this->acro['word'][$sumAcro] = $rWord;
			        $this->acro['mean'][$sumAcro] = $rMean;
			        $this->acro['lang'][$sumAcro] = $rLang;
			        
			   		$this->acro['sys_language_uid'][$sumAcro] = $row['sys_language_uid'];

	 				$this->acro['showglossary'][$sumAcro] = $row['showglossary'];
			        $sumAcro++;
			        break;
 	 			}
	        	case 'span' : {
	          		$this->span['uid'][$sumSpan] = $row['uid'];
	          		
	          		$this->span['word'][$sumSpan] = $rWord;
	          		$this->span['mean'][$sumSpan] = $rMean;
	          		$this->span['lang'][$sumSpan] = $rLang;
	          		
	            	$this->span['sys_language_uid'][$sumSpan] = $row['sys_language_uid'];
	          		$this->span['showglossary'][$sumSpan] = $row['showglossary'];
	          		$sumSpan++;
	          		break;
	        	}
	        	case 'term' : {
			        $this->term['uid'][$sumTerm] = $row['uid'];
			        
			        $this->term['word'][$sumTerm] = $rWord;
			        $this->term['mean'][$sumTerm] = $rMean;
			        $this->term['lang'][$sumTerm] = $rLang;
			        
			   		$this->term['sys_language_uid'][$sumTerm] = $row['sys_language_uid'];
			        $this->term['showglossary'][$sumTerm] = $row['showglossary'];
			        $sumTerm++;
			        break;
	        	}
	        	case 'nowrap' : {
	          		$nowrap[] = $rWord;
	          		break;
				}
	      	}
		}

    	$this->cabbr = count($this->abbr['mean'])?true:false;
	    $this->cacro = count($this->acro['mean'])?true:false;
	    $this->cspan = count($this->span['mean'])?true:false;
	    $this->cterm = count($this->term['mean'])?true:false;
		$this->lang = ' lang="%lang%" xml:lang="%lang%"';
		$this->strAbbr = '<abbr%s title="%s">%s</abbr>';
		$this->strAcro = '<acronym%s title="%s">%s</acronym>';
		$this->strSpan = '<span%s title="%s">%s</span>';
		$this->strTerm = '<span%s title="%s">%s</span>';
		$this->strNoSpan = '%s title="%s"';

		// getTypoLink_URL
		$this->linkurl=$this->cObj->getTypoLink_URL($glossary_pid,array($this->prefixId=>array('pseudo' => 'true')));
		// define seperators
		$exploder = array(' ','-',')','(',']','[',',',';',':','!','?','"',"\n","\r",'&quot;','&nbsp;');
		$a=0;$word='';
		for($i=0;$i<strlen($text);$i++) {
			if (strstr($text[$i],"<")) {
        	// handle tags
				$u=$i;
				$end[$a].=$text[$i];
				do {
					$i++;
					$end[$a].=$text[$i];
				}	while(($text[$i]!=">") AND ($text[($i+1)]!="<") AND ($text[$i]!=""));

				if ($text[$i]=="<" AND ($i>($u+1))) {
					$a++;
					if ($word[$a]=="") $word[$a] = '~~NO~WORD~~';
				} else {
					if ($word[$a]=="") $word[$a] = '~~NO~WORD~~';
					$a++;
				}
			}	else if (in_array($text[$i],$exploder)) {
			// handle new word
				$end[$a].= $text[$i];
				if ($word[$a]=="") $word[$a] = '~~NO~WORD~~';
				$a++;

			}	else if (in_array($sub=substr($text, $i, 6),$exploder)) {
			// handle new word
				$end[$a].= $sub;
				$i += 5;
				if ($word[$a]=="") $word[$a] = '~~NO~WORD~~';
				$a++;
			} else {
        	// build word
        	$word[$a] .= $text[$i];
      		}
		}
		$i=0;
		$currentWrap = '';
		while($i<sizeof($word)) {
			$i_step = 1;
			$i_end = $i;
			$this->getCurrentWrap($end[$i-1], $currentWrap, $nowrap);
			$sword = $word[$i];
			// looking for phrases
			$slong = $word[$i];
			for($j=1;$j<=$pmax;$j++) {
				$slong .= ' '.$word[$i+$j];
				if($phrase[$j] && in_array($slong, $phrase[$j])) {
					$sword = $slong;
					$i_step += $j;
					$i_end += $j;
				}
			}
			// looking for hyphenate words
			if($sword==$word[$i] && $end[$i]=='-') {
				$slong = $word[$i];
				for($j=1;$j<=$hmax;$j++) {
					$slong .= $end[$i+$j-1].$word[$i+$j];
					if($hyphenate[$j] && in_array($slong, $hyphenate[$j])) {
						$sword = $slong;
						$i_step += $j;
						$i_end += $j;
					}
				}
			}

	    	$wrap = ($end[$i-1][0]=='<' && $end[$i-1][1]<>'/' && substr($end[$i_end],0,2)=='</') ? false : true;
      		if($sword<>'~~NO~WORD~~') {
				if($currentWrap=='') {
	        		$short = '';
	        		if(substr($sword, -1) == '.') $short = substr($sword, 0, -1);
	                $replace = '';
					$newWord = $this->getWrapedWord($sword, $wrap, $replace);
					if($replace=='' && $newWord==$sword && $short<>'') {
						$newWord = $this->getWrapedWord($short, $wrap, $replace).'.';
					}
					if($replace<>'') {
						// use the wraped TAG instead of the span TAG
						$output = substr($output,0,-1).$replace;
					}
	   				$output .= $newWord;
  				} else {
  				$output .= $sword;
				}
			}
			$output .= $end[$i_end];
			$i += $i_step;
		}
		return $output;
	}

	/**
	 * getCurrentWrap function: detects a wraped tag
	 *
	 * @param	string  $item : tag
	 * @param	string  &$wrap : pointer to open tag
	 * @param	array   $nowrap : array of forbidden tags
	 * @return
	 */

	function getCurrentWrap($item, &$wrap, $nowrap) {

		$strpos1 = strpos($item, ' ');
		$strpos2 = strpos($item, '>');
		if($strpos1 === false) $strpos1 = $strpos2;

		$item = trim(substr($item, 1, $strpos1));
		if($wrap<>'') {
			if(substr($item, 0, strlen($wrap)+1)=='/'.$wrap) $wrap = '';
		} else {
			if(in_array($item, $nowrap)) $wrap = $item;
		}
	}

	/**
	 * getWrapedWord function: wraps a word with information tag
	 *
	 * @param	string  $word : word to wrap
	 * @param	bool    $wrap : true, if it is allowed to wrap the word
	 * @param	string  &$replace : use this string instead of the span tag
	 * @return string $result: the wraped word
	 */

	function getWrapedWord($word, $wrap, &$replace) {
		$result = $word;
		$mean='';$language='';
		$myURLname=$this->pi_getPageLink($GLOBALS['TSFE']->id);
		$sysLanguageUid = $GLOBALS['TSFE']->config['config']['sys_language_uid'];

		if ($this->cacro && is_int($z=array_search($word,$this->acro['word']))) {
				$language=($this->acro['lang'][$z]<>$this->language?str_replace('%lang%',$this->acro['lang'][$z],$this->lang):'');
				if($this->acro['showglossary'][$z]){
						if($this->glossaryonpage==true){
							$mean =	 $this->acro['mean'][$z];
							$result = '<acronym '.$language.'class="glossaryentry" title="'.$this->glossaryEntryLabel.'">'.$word.'</acronym>';
						}else{
	      				$linkurl=$this->linkurl.'#sbakronymmanager'.($this->acro['uid'][$z]);
						$mean =	 $this->acro['mean'][$z];
						$result = '<a href="'.$linkurl.'" class="glossarlink"  title="'.$this->glossaryEntryLabel.'" ><acronym '.$language.' title="'.$mean.'" >'.$word.'</acronym></a>';
						}
						$GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_sbakronymmanager_index', array('page_id' => ($GLOBALS['TSFE']->id),'page_link' => $myURLname, 'word' => $word, 'sys_language_uid'=>$sysLanguageUid, 'tx_sbakronymmanager_data_id' => (($this->acro['uid'][$z]))));
				}else{
	    				$result = sprintf($this->strAcro,
							($this->acro['lang'][$z]<>$this->language?str_replace('%lang%',$this->acro['lang'][$z],$this->lang):''),
							 $this->acro['mean'][$z],$word);
				}
	    }

	    else if ($this->cabbr && is_int($z=array_search($word,$this->abbr['word']))) {
				$language=($this->abbr['lang'][$z]<>$this->language?str_replace('%lang%',$this->abbr['lang'][$z],$this->lang):'');
	    		if($this->abbr['showglossary'][$z]){
						if($this->glossaryonpage==true){
							$result = '<span '.$language.' class="glossaryentry" title="'.$this->glossaryEntryLabel.'"><abbr '.$language.'>'.$word.'</abbr></span>';
						}else{
		      				$linkurl=$this->linkurl.'#sbakronymmanager'.($this->abbr['uid'][$z]);
							$mean =	 $this->abbr['mean'][$z];
							$result = '<a class="glossarlink" title="'.$this->glossaryEntryLabel.'" href="'.$linkurl.'"><abbr '.$language.' title="'.$mean.'">'.$word.'</abbr></a>';
						}
				$GLOBALS['TYPO3_DB']->exec_INSERTquery(
					'tx_sbakronymmanager_index',
						array('page_id' => ($GLOBALS['TSFE']->id),
						'page_link' => $myURLname,
						'word' => $word,
						'sys_language_uid'=>$sysLanguageUid,
						'tx_sbakronymmanager_data_id' => ($this->abbr['uid'][$z])
						)
					);
	    		}else {
	    			$result = sprintf($this->strAbbr, ($this->abbr['lang'][$z]<>$this->language?str_replace('%lang%', $this->abbr['lang'][$z], $this->lang):''),
	    				   $this->abbr['mean'][$z], $word);
	    		}
	    }

	    else if ($this->cspan && is_int($z=array_search($word,$this->span['word']))) {
				$language=($this->span['lang'][$z]<>$this->language?str_replace('%lang%',$this->span['lang'][$z],$this->lang):'');
	      		if($this->span['showglossary'][$z]){
	      				if($this->glossaryonpage==true){
							$result = '<span '.$language.' class="glossaryentry" title="'.$this->glossaryEntryLabel.'">'.$word.'</span>';
						}else{
						$linkurl=$this->linkurl.'#sbakronymmanager'.($this->span['uid'][$z]);
				    	$mean =	 $this->span['mean'][$z];
						  $result = '<a class="glossarlink" title="'.$this->glossaryEntryLabel.'" href="'.$linkurl.'" '.$language.'>'.$word.'</a>';
	      				}
						$GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_sbakronymmanager_index', array('page_id' => ($GLOBALS['TSFE']->id),'page_link' => $myURLname, 'word' => $word, 'sys_language_uid'=>$sysLanguageUid, 'tx_sbakronymmanager_data_id' => (($this->span['uid'][$z]))));

	      		}else { 
					if($wrap){
							$result =  sprintf($this->strSpan,   ($this->span['lang'][$z]<>$this->language?str_replace('%lang%', $this->span['lang'][$z], $this->lang):''),
															      $this->span['mean'][$z], $word);
					} else {
							$replace = sprintf($this->strNoSpan, ($this->span['lang'][$z]<>$this->language?str_replace('%lang%', $this->span['lang'][$z], $this->lang):''),
																  $this->span['mean'][$z]).'>';
					}
      		}
	    }
		else if ($this->cterm && is_int($z=array_search($word,$this->term['word']))) {
		 		$language=($this->term['lang'][$z]<>$this->language?str_replace('%lang%',
																				$this->term['lang'][$z],
																				$this->lang
																			   ):''
				   		  );
				if($this->term['showglossary'][$z]){
	      				if($this->glossaryonpage==true){
							$result = '<span '.$language.' class="glossaryentry" title="'.$this->glossaryEntryLabel.'">'.$word.'</span>';
						}else{
				    	$linkurl=$this->linkurl.'#sbakronymmanager'.($this->term['uid'][$z]);
				    	$mean =	 $this->term['mean'][$z];
						  $result = '<a class="glossarlink" title="'.$this->glossaryEntryLabel.'" href="'.$linkurl.'" '.$language.'>'.$word.'</a>';
	      				}
						$GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_sbakronymmanager_index', array('page_id' => ($GLOBALS['TSFE']->id),'page_link' => $myURLname, 'word' => $word, 'sys_language_uid'=>$sysLanguageUid, 'tx_sbakronymmanager_data_id' => (($this->term['uid'][$z]))));
				    }else { 
						if($wrap){
								$result =  sprintf($this->strTerm,   ($this->term['lang'][$z]<>$this->language?str_replace('%lang%', $this->term['lang'][$z], $this->lang):''),
																      $this->term['mean'][$z], $word);
						} else {
								$replace = sprintf($this->strNoSpan, ($this->term['lang'][$z]<>$this->language?str_replace('%lang%', $this->term['lang'][$z], $this->lang):''),
																	  $this->term['mean'][$z]).'>';
						}
				    }
		}
		return $result;
	}
	
	function sanitize($txt) {
		global $TYPO3_CONF_VARS;
		$sTxt = htmlspecialchars(strip_tags($txt), ENT_QUOTES, '', false);
		return $sTxt;
	}	
}	


if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sb_akronymmanager/pi1/class.tx_sbakronymmanager_pi1.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sb_akronymmanager/pi1/class.tx_sbakronymmanager_pi1.php"]);
}

?>