<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2006 Juergen Kindler <kindler@sunbeam-berlin.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
class tx_sbakronymmanager_pi2 extends tslib_pibase {
    var $prefixId = 'tx_sbakronymmanager_pi2';        				// Same as class name
    var $scriptRelPath = 'pi2/class.tx_sbakronymmanager_pi2.php';   // Path to this script relative to the extension dir.
    var $extKey = 'sb_akronymmanager';    							// The extension key.
    var $pi_checkCHash = TRUE;

    /**
     * The main method of the PlugIn
     *
     * @param    string        $content: The PlugIn content
     * @param    array        $conf: The PlugIn configuration
     * @return    The content that is displayed on the website
    */
 function main($content,$conf)    {
        $this->conf=$conf;
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();
	
	$myFileName=$this->pi_getPageLink($GLOBALS['TSFE']->id);

	// page with records should be set in plugin
	$glossaryOrder = (int)$this->cObj->data['pages'];

	if ($glossaryOrder != '') {
	 $tempHTML='';
   	 $sysLanguageUid = $GLOBALS['TSFE']->config['config']['sys_language_uid'];   		
     $select = '`uid`,`word`,`glossary`,`showglossary`';
     $where = ' hidden=0 AND deleted=0  AND showglossary=true AND sys_language_uid='.(int)$sysLanguageUid.' AND pid='.$glossaryOrder;
	 $result = $GLOBALS['TYPO3_DB']->exec_SELECTquery($select,'tx_sbakronymmanager_data',$where,$orderBy='word');
	 while($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($result)) {
		$dword = utf8_decode(strip_tags($row['word']));
		$Glossary[$dword]['Word']='<a name="sbakronymmanager'.$row['uid'].'"></a><dl><dt>'.strip_tags($row['word']).'</dt>';
		$Glossary[$dword]['Glossary']='<dd>'.$this->rteParser($row['glossary']).'</dd></dl>';
		$tempABC='';
		//function xChangeUmlaut() will eliminate umlaut. 'Ä'->'A'
		$tempABC =$this->xChangeUmlaut(strtoupper((substr($dword,0,1))));
		$ABC3[$tempABC]['Word']='<a name="'.$tempABC.'"></a><div class="header-wrap"><h3>'.utf8_encode($tempABC).'</h3></div>';
		$ABC_Register_Links[$tempABC]['Word']='<li><a href="'.$myFileName.'#'.$tempABC.'">'.utf8_encode($tempABC).'</a> </li>';
	 }

	$Glossary= array_merge($ABC3 ,$Glossary);
	$GlossaryKeys=(array_keys($Glossary));
	//without this line alphabetical sorting doesn't work for english language
	setlocale(LC_ALL, 'de_DE');
	asort($GlossaryKeys, SORT_LOCALE_STRING); 
	$array_lowercase = array_map('strtolower', $GlossaryKeys);
	array_merge($array_lowercase, $GlossaryKeys);
	$Glossary2=array();
	foreach($GlossaryKeys as $key) {
		$Glossary2[$key]=$Glossary[$key];
	}
	$ret=array_keys($Glossary2);
	foreach($ret as $var) {
		$tempHTML=$tempHTML.$Glossary[$var]['Word'].$Glossary[$var]['Glossary'];
	}

		// ABC-Register:
		$ABC1['A']['Word']='<li><span>A</span></li>';
		$ABC1['B']['Word']='<li><span>B</span></li>';
		$ABC1['C']['Word']='<li><span>C</span></li>';
		$ABC1['D']['Word']='<li><span>D</span></li>';
		$ABC1['E']['Word']='<li><span>E</span></li>';
		$ABC1['F']['Word']='<li><span>F</span></li>';
		$ABC1['G']['Word']='<li><span>G</span></li>';
		$ABC1['H']['Word']='<li><span>H</span></li>';
		$ABC1['I']['Word']='<li><span>I</span></li>';
		$ABC1['J']['Word']='<li><span>J</span></li>';
		$ABC1['K']['Word']='<li><span>K</span></li>';
		$ABC1['L']['Word']='<li><span>L</span></li>';
		$ABC1['M']['Word']='<li><span>M</span></li>';
		$ABC1['N']['Word']='<li><span>N</span></li>';
		$ABC1['O']['Word']='<li><span>O</span></li>';
		$ABC1['P']['Word']='<li><span>P</span></li>';
		$ABC1['Q']['Word']='<li><span>Q</span></li>';
		$ABC1['R']['Word']='<li><span>R</span></li>';
		$ABC1['S']['Word']='<li><span>S</span></li>';
		$ABC1['T']['Word']='<li><span>T</span></li>';
		$ABC1['U']['Word']='<li><span>U</span></li>';
		$ABC1['V']['Word']='<li><span>V</span></li>';
		$ABC1['W']['Word']='<li><span>W</span></li>';
		$ABC1['X']['Word']='<li><span>X</span></li>';
		$ABC1['Y']['Word']='<li><span>Y</span></li>';
		$ABC1['Z']['Word']='<li><span>Z</span></li>';
		$Register = array_merge($ABC1,$ABC_Register_Links);
		
		$reg=array_keys($Register);
		$HTMLRegister='<div id="azindex"><ul id="index" class="clearfix">';
			foreach($reg as $var) $HTMLRegister=$HTMLRegister.$Register[$var]['Word'];
		$HTMLRegister=$HTMLRegister.'</ul></div>';
		$content=$HTMLRegister.$tempHTML.'<p class="csc-linkToTop">
			<a href="'.$myFileName.'#" title="'.$this->pi_getLL('linkToTop').'">'.$this->pi_getLL('linkToTop').'</a>
			</p>
		';
   return $this->pi_wrapInBaseClass($content);
    
        
    }else{
		$content = '<div style="border:2px solid red;padding:10px;margin:10px;">
			<img src="typo3/gfx/icon_warning2.gif">
			 <strong>sb_akronymmanager:<br /> 
			 please set repository with your records<br />
			 </strong>
			 </div>';
			return $this->pi_wrapInBaseClass($content);
	}   
    
 }

	function rteParser($value){
		$setup['value'] = $value;
		$setup['parseFunc'] = '< lib.parseFunc_RTE';
		return $this->cObj->cObjGetSingle('TEXT', $setup);
	}

	/**
	 * 
	 * Enter description here ...
	 * will eliminate umlaut. 'Ä'->'A'
	 * @param unknown_type $uml
	 */
	function xChangeUmlaut($uml) {
		$umlArray = array('Ä'=>'A', 'Ö'=>'O', 'Ü'=>'U');
		if (array_key_exists($uml, $umlArray))
			return ($umlArray[$uml]);
		else
			return ($uml);
	}

}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/sb_akronymmanager/pi2/class.tx_sbakronymmanager_pi2.php'])    {
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/sb_akronymmanager/pi2/class.tx_sbakronymmanager_pi2.php']);
}

?>